#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__TAttLine__
#define __HROOT_CORE__TAttLine__

#include "HROOT-coreType.h"

#include "HROOTCoreDeletable.h"

#undef TATTLINE_DECL_VIRT
#define TATTLINE_DECL_VIRT(Type) \
int Type ## _GetLineColor ( Type ## _p p ); \
int Type ## _GetLineStyle ( Type ## _p p ); \
int Type ## _GetLineWidth ( Type ## _p p ); \
void Type ## _ResetAttLine ( Type ## _p p, const char* option ); \
void Type ## _SetLineAttributes ( Type ## _p p ); \
void Type ## _SetLineColor ( Type ## _p p, int lcolor ); \
void Type ## _SetLineStyle ( Type ## _p p, int lstyle ); \
void Type ## _SetLineWidth ( Type ## _p p, int lwidth )

#undef TATTLINE_DECL_NONVIRT
#define TATTLINE_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTAttLine ( int lcolor, int lstyle, int lwidth ); \
int Type ## _tAttLineDistancetoLine ( Type ## _p p, int px, int py, double xp1, double yp1, double xp2, double yp2 )

#undef TATTLINE_DEF_VIRT
#define TATTLINE_DEF_VIRT(Type)\
int Type ## _GetLineColor ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetLineColor,TAttLine)(p)->GetLineColor();\
}\
int Type ## _GetLineStyle ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetLineStyle,TAttLine)(p)->GetLineStyle();\
}\
int Type ## _GetLineWidth ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetLineWidth,TAttLine)(p)->GetLineWidth();\
}\
void Type ## _ResetAttLine ( Type ## _p p, const char* option )\
{\
TYPECASTMETHOD(Type,ResetAttLine,TAttLine)(p)->ResetAttLine(option);\
}\
void Type ## _SetLineAttributes ( Type ## _p p )\
{\
TYPECASTMETHOD(Type,SetLineAttributes,TAttLine)(p)->SetLineAttributes();\
}\
void Type ## _SetLineColor ( Type ## _p p, int lcolor )\
{\
TYPECASTMETHOD(Type,SetLineColor,TAttLine)(p)->SetLineColor(lcolor);\
}\
void Type ## _SetLineStyle ( Type ## _p p, int lstyle )\
{\
TYPECASTMETHOD(Type,SetLineStyle,TAttLine)(p)->SetLineStyle(lstyle);\
}\
void Type ## _SetLineWidth ( Type ## _p p, int lwidth )\
{\
TYPECASTMETHOD(Type,SetLineWidth,TAttLine)(p)->SetLineWidth(lwidth);\
}

#undef TATTLINE_DEF_NONVIRT
#define TATTLINE_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTAttLine ( int lcolor, int lstyle, int lwidth )\
{\
Type * newp = new Type (lcolor, lstyle, lwidth); \
return to_nonconst<Type ## _t, Type >(newp);\
}\
int Type ## _tAttLineDistancetoLine ( Type ## _p p, int px, int py, double xp1, double yp1, double xp2, double yp2 )\
{\
return TYPECASTMETHOD(Type,tAttLineDistancetoLine,TAttLine)(p)->DistancetoLine(px, py, xp1, yp1, xp2, yp2);\
}

DELETABLE_DECL_VIRT(TAttLine);


TATTLINE_DECL_VIRT(TAttLine);


TATTLINE_DECL_NONVIRT(TAttLine);


#endif // __HROOT_CORE__TAttLine__

#ifdef __cplusplus
}
#endif
