#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__TAttMarker__
#define __HROOT_CORE__TAttMarker__

#include "HROOT-coreType.h"

#include "HROOTCoreDeletable.h"

#undef TATTMARKER_DECL_VIRT
#define TATTMARKER_DECL_VIRT(Type) \
int Type ## _GetMarkerColor ( Type ## _p p ); \
int Type ## _GetMarkerStyle ( Type ## _p p ); \
double Type ## _GetMarkerSize ( Type ## _p p ); \
void Type ## _ResetAttMarker ( Type ## _p p, const char* option ); \
void Type ## _SetMarkerAttributes ( Type ## _p p ); \
void Type ## _SetMarkerColor ( Type ## _p p, int tcolor ); \
void Type ## _SetMarkerStyle ( Type ## _p p, int mstyle ); \
void Type ## _SetMarkerSize ( Type ## _p p, int msize )

#undef TATTMARKER_DECL_NONVIRT
#define TATTMARKER_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTAttMarker ( int color, int style, int msize )

#undef TATTMARKER_DEF_VIRT
#define TATTMARKER_DEF_VIRT(Type)\
int Type ## _GetMarkerColor ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetMarkerColor,TAttMarker)(p)->GetMarkerColor();\
}\
int Type ## _GetMarkerStyle ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetMarkerStyle,TAttMarker)(p)->GetMarkerStyle();\
}\
double Type ## _GetMarkerSize ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetMarkerSize,TAttMarker)(p)->GetMarkerSize();\
}\
void Type ## _ResetAttMarker ( Type ## _p p, const char* option )\
{\
TYPECASTMETHOD(Type,ResetAttMarker,TAttMarker)(p)->ResetAttMarker(option);\
}\
void Type ## _SetMarkerAttributes ( Type ## _p p )\
{\
TYPECASTMETHOD(Type,SetMarkerAttributes,TAttMarker)(p)->SetMarkerAttributes();\
}\
void Type ## _SetMarkerColor ( Type ## _p p, int tcolor )\
{\
TYPECASTMETHOD(Type,SetMarkerColor,TAttMarker)(p)->SetMarkerColor(tcolor);\
}\
void Type ## _SetMarkerStyle ( Type ## _p p, int mstyle )\
{\
TYPECASTMETHOD(Type,SetMarkerStyle,TAttMarker)(p)->SetMarkerStyle(mstyle);\
}\
void Type ## _SetMarkerSize ( Type ## _p p, int msize )\
{\
TYPECASTMETHOD(Type,SetMarkerSize,TAttMarker)(p)->SetMarkerSize(msize);\
}

#undef TATTMARKER_DEF_NONVIRT
#define TATTMARKER_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTAttMarker ( int color, int style, int msize )\
{\
Type * newp = new Type (color, style, msize); \
return to_nonconst<Type ## _t, Type >(newp);\
}

DELETABLE_DECL_VIRT(TAttMarker);


TATTMARKER_DECL_VIRT(TAttMarker);


TATTMARKER_DECL_NONVIRT(TAttMarker);


#endif // __HROOT_CORE__TAttMarker__

#ifdef __cplusplus
}
#endif
