#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__TAttPad__
#define __HROOT_CORE__TAttPad__

#include "HROOT-coreType.h"

#include "HROOTCoreDeletable.h"

#undef TATTPAD_DECL_VIRT
#define TATTPAD_DECL_VIRT(Type) \
void Type ## _ResetAttPad ( Type ## _p p, const char* option ); \
void Type ## _SetBottomMargin ( Type ## _p p, double bottommargin ); \
void Type ## _SetLeftMargin ( Type ## _p p, double leftmargin ); \
void Type ## _SetRightMargin ( Type ## _p p, double rightmargin ); \
void Type ## _SetTopMargin ( Type ## _p p, double topmargin ); \
void Type ## _SetMargin ( Type ## _p p, double left, double right, double bottom, double top ); \
void Type ## _SetAfile ( Type ## _p p, double afile ); \
void Type ## _SetXfile ( Type ## _p p, double xfile ); \
void Type ## _SetYfile ( Type ## _p p, double yfile ); \
void Type ## _SetAstat ( Type ## _p p, double astat ); \
void Type ## _SetXstat ( Type ## _p p, double xstat ); \
void Type ## _SetYstat ( Type ## _p p, double ystat )

#undef TATTPAD_DECL_NONVIRT
#define TATTPAD_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTAttPad (  ); \
double Type ## _tAttPadGetBottomMargin ( Type ## _p p ); \
double Type ## _tAttPadGetLeftMargin ( Type ## _p p ); \
double Type ## _tAttPadGetRightMargin ( Type ## _p p ); \
double Type ## _tAttPadGetTopMargin ( Type ## _p p ); \
double Type ## _tAttPadGetAfile ( Type ## _p p ); \
double Type ## _tAttPadGetXfile ( Type ## _p p ); \
double Type ## _tAttPadGetYfile ( Type ## _p p ); \
double Type ## _tAttPadGetAstat ( Type ## _p p ); \
double Type ## _tAttPadGetXstat ( Type ## _p p ); \
double Type ## _tAttPadGetYstat ( Type ## _p p ); \
int Type ## _tAttPadGetFrameFillColor ( Type ## _p p ); \
int Type ## _tAttPadGetFrameLineColor ( Type ## _p p ); \
int Type ## _tAttPadGetFrameFillStyle ( Type ## _p p ); \
int Type ## _tAttPadGetFrameLineStyle ( Type ## _p p ); \
int Type ## _tAttPadGetFrameLineWidth ( Type ## _p p ); \
int Type ## _tAttPadGetFrameBorderSize ( Type ## _p p ); \
int Type ## _tAttPadGetFrameBorderMode ( Type ## _p p ); \
void Type ## _tAttPadSetFrameFillColor ( Type ## _p p, int color ); \
void Type ## _tAttPadSetFrameLineColor ( Type ## _p p, int color ); \
void Type ## _tAttPadSetFrameFillStyle ( Type ## _p p, int styl ); \
void Type ## _tAttPadSetFrameLineStyle ( Type ## _p p, int styl ); \
void Type ## _tAttPadSetFrameLineWidth ( Type ## _p p, int width ); \
void Type ## _tAttPadSetFrameBorderSize ( Type ## _p p, int size ); \
void Type ## _tAttPadSetFrameBorderMode ( Type ## _p p, int mode )

#undef TATTPAD_DEF_VIRT
#define TATTPAD_DEF_VIRT(Type)\
void Type ## _ResetAttPad ( Type ## _p p, const char* option )\
{\
TYPECASTMETHOD(Type,ResetAttPad,TAttPad)(p)->ResetAttPad(option);\
}\
void Type ## _SetBottomMargin ( Type ## _p p, double bottommargin )\
{\
TYPECASTMETHOD(Type,SetBottomMargin,TAttPad)(p)->SetBottomMargin(bottommargin);\
}\
void Type ## _SetLeftMargin ( Type ## _p p, double leftmargin )\
{\
TYPECASTMETHOD(Type,SetLeftMargin,TAttPad)(p)->SetLeftMargin(leftmargin);\
}\
void Type ## _SetRightMargin ( Type ## _p p, double rightmargin )\
{\
TYPECASTMETHOD(Type,SetRightMargin,TAttPad)(p)->SetRightMargin(rightmargin);\
}\
void Type ## _SetTopMargin ( Type ## _p p, double topmargin )\
{\
TYPECASTMETHOD(Type,SetTopMargin,TAttPad)(p)->SetTopMargin(topmargin);\
}\
void Type ## _SetMargin ( Type ## _p p, double left, double right, double bottom, double top )\
{\
TYPECASTMETHOD(Type,SetMargin,TAttPad)(p)->SetMargin(left, right, bottom, top);\
}\
void Type ## _SetAfile ( Type ## _p p, double afile )\
{\
TYPECASTMETHOD(Type,SetAfile,TAttPad)(p)->SetAfile(afile);\
}\
void Type ## _SetXfile ( Type ## _p p, double xfile )\
{\
TYPECASTMETHOD(Type,SetXfile,TAttPad)(p)->SetXfile(xfile);\
}\
void Type ## _SetYfile ( Type ## _p p, double yfile )\
{\
TYPECASTMETHOD(Type,SetYfile,TAttPad)(p)->SetYfile(yfile);\
}\
void Type ## _SetAstat ( Type ## _p p, double astat )\
{\
TYPECASTMETHOD(Type,SetAstat,TAttPad)(p)->SetAstat(astat);\
}\
void Type ## _SetXstat ( Type ## _p p, double xstat )\
{\
TYPECASTMETHOD(Type,SetXstat,TAttPad)(p)->SetXstat(xstat);\
}\
void Type ## _SetYstat ( Type ## _p p, double ystat )\
{\
TYPECASTMETHOD(Type,SetYstat,TAttPad)(p)->SetYstat(ystat);\
}

#undef TATTPAD_DEF_NONVIRT
#define TATTPAD_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTAttPad (  )\
{\
Type * newp = new Type (); \
return to_nonconst<Type ## _t, Type >(newp);\
}\
double Type ## _tAttPadGetBottomMargin ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetBottomMargin,TAttPad)(p)->GetBottomMargin();\
}\
double Type ## _tAttPadGetLeftMargin ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetLeftMargin,TAttPad)(p)->GetLeftMargin();\
}\
double Type ## _tAttPadGetRightMargin ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetRightMargin,TAttPad)(p)->GetRightMargin();\
}\
double Type ## _tAttPadGetTopMargin ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetTopMargin,TAttPad)(p)->GetTopMargin();\
}\
double Type ## _tAttPadGetAfile ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetAfile,TAttPad)(p)->GetAfile();\
}\
double Type ## _tAttPadGetXfile ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetXfile,TAttPad)(p)->GetXfile();\
}\
double Type ## _tAttPadGetYfile ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetYfile,TAttPad)(p)->GetYfile();\
}\
double Type ## _tAttPadGetAstat ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetAstat,TAttPad)(p)->GetAstat();\
}\
double Type ## _tAttPadGetXstat ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetXstat,TAttPad)(p)->GetXstat();\
}\
double Type ## _tAttPadGetYstat ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetYstat,TAttPad)(p)->GetYstat();\
}\
int Type ## _tAttPadGetFrameFillColor ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetFrameFillColor,TAttPad)(p)->GetFrameFillColor();\
}\
int Type ## _tAttPadGetFrameLineColor ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetFrameLineColor,TAttPad)(p)->GetFrameLineColor();\
}\
int Type ## _tAttPadGetFrameFillStyle ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetFrameFillStyle,TAttPad)(p)->GetFrameFillStyle();\
}\
int Type ## _tAttPadGetFrameLineStyle ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetFrameLineStyle,TAttPad)(p)->GetFrameLineStyle();\
}\
int Type ## _tAttPadGetFrameLineWidth ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetFrameLineWidth,TAttPad)(p)->GetFrameLineWidth();\
}\
int Type ## _tAttPadGetFrameBorderSize ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetFrameBorderSize,TAttPad)(p)->GetFrameBorderSize();\
}\
int Type ## _tAttPadGetFrameBorderMode ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,tAttPadGetFrameBorderMode,TAttPad)(p)->GetFrameBorderMode();\
}\
void Type ## _tAttPadSetFrameFillColor ( Type ## _p p, int color )\
{\
TYPECASTMETHOD(Type,tAttPadSetFrameFillColor,TAttPad)(p)->SetFrameFillColor(color);\
}\
void Type ## _tAttPadSetFrameLineColor ( Type ## _p p, int color )\
{\
TYPECASTMETHOD(Type,tAttPadSetFrameLineColor,TAttPad)(p)->SetFrameLineColor(color);\
}\
void Type ## _tAttPadSetFrameFillStyle ( Type ## _p p, int styl )\
{\
TYPECASTMETHOD(Type,tAttPadSetFrameFillStyle,TAttPad)(p)->SetFrameFillStyle(styl);\
}\
void Type ## _tAttPadSetFrameLineStyle ( Type ## _p p, int styl )\
{\
TYPECASTMETHOD(Type,tAttPadSetFrameLineStyle,TAttPad)(p)->SetFrameLineStyle(styl);\
}\
void Type ## _tAttPadSetFrameLineWidth ( Type ## _p p, int width )\
{\
TYPECASTMETHOD(Type,tAttPadSetFrameLineWidth,TAttPad)(p)->SetFrameLineWidth(width);\
}\
void Type ## _tAttPadSetFrameBorderSize ( Type ## _p p, int size )\
{\
TYPECASTMETHOD(Type,tAttPadSetFrameBorderSize,TAttPad)(p)->SetFrameBorderSize(size);\
}\
void Type ## _tAttPadSetFrameBorderMode ( Type ## _p p, int mode )\
{\
TYPECASTMETHOD(Type,tAttPadSetFrameBorderMode,TAttPad)(p)->SetFrameBorderMode(mode);\
}

DELETABLE_DECL_VIRT(TAttPad);


TATTPAD_DECL_VIRT(TAttPad);


TATTPAD_DECL_NONVIRT(TAttPad);


#endif // __HROOT_CORE__TAttPad__

#ifdef __cplusplus
}
#endif
