#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__TAttText__
#define __HROOT_CORE__TAttText__

#include "HROOT-coreType.h"

#include "HROOTCoreDeletable.h"

#undef TATTTEXT_DECL_VIRT
#define TATTTEXT_DECL_VIRT(Type) \
int Type ## _GetTextAlign ( Type ## _p p ); \
double Type ## _GetTextAngle ( Type ## _p p ); \
int Type ## _GetTextColor ( Type ## _p p ); \
int Type ## _GetTextFont ( Type ## _p p ); \
double Type ## _GetTextSize ( Type ## _p p ); \
void Type ## _ResetAttText ( Type ## _p p, const char* toption ); \
void Type ## _SetTextAttributes ( Type ## _p p ); \
void Type ## _SetTextAlign ( Type ## _p p, int align ); \
void Type ## _SetTextAngle ( Type ## _p p, double tangle ); \
void Type ## _SetTextColor ( Type ## _p p, int tcolor ); \
void Type ## _SetTextFont ( Type ## _p p, int tfont ); \
void Type ## _SetTextSize ( Type ## _p p, double tsize ); \
void Type ## _SetTextSizePixels ( Type ## _p p, int npixels )

#undef TATTTEXT_DECL_NONVIRT
#define TATTTEXT_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTAttText ( int align, double angle, int color, int font, double tsize )

#undef TATTTEXT_DEF_VIRT
#define TATTTEXT_DEF_VIRT(Type)\
int Type ## _GetTextAlign ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetTextAlign,TAttText)(p)->GetTextAlign();\
}\
double Type ## _GetTextAngle ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetTextAngle,TAttText)(p)->GetTextAngle();\
}\
int Type ## _GetTextColor ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetTextColor,TAttText)(p)->GetTextColor();\
}\
int Type ## _GetTextFont ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetTextFont,TAttText)(p)->GetTextFont();\
}\
double Type ## _GetTextSize ( Type ## _p p )\
{\
return TYPECASTMETHOD(Type,GetTextSize,TAttText)(p)->GetTextSize();\
}\
void Type ## _ResetAttText ( Type ## _p p, const char* toption )\
{\
TYPECASTMETHOD(Type,ResetAttText,TAttText)(p)->ResetAttText(toption);\
}\
void Type ## _SetTextAttributes ( Type ## _p p )\
{\
TYPECASTMETHOD(Type,SetTextAttributes,TAttText)(p)->SetTextAttributes();\
}\
void Type ## _SetTextAlign ( Type ## _p p, int align )\
{\
TYPECASTMETHOD(Type,SetTextAlign,TAttText)(p)->SetTextAlign(align);\
}\
void Type ## _SetTextAngle ( Type ## _p p, double tangle )\
{\
TYPECASTMETHOD(Type,SetTextAngle,TAttText)(p)->SetTextAngle(tangle);\
}\
void Type ## _SetTextColor ( Type ## _p p, int tcolor )\
{\
TYPECASTMETHOD(Type,SetTextColor,TAttText)(p)->SetTextColor(tcolor);\
}\
void Type ## _SetTextFont ( Type ## _p p, int tfont )\
{\
TYPECASTMETHOD(Type,SetTextFont,TAttText)(p)->SetTextFont(tfont);\
}\
void Type ## _SetTextSize ( Type ## _p p, double tsize )\
{\
TYPECASTMETHOD(Type,SetTextSize,TAttText)(p)->SetTextSize(tsize);\
}\
void Type ## _SetTextSizePixels ( Type ## _p p, int npixels )\
{\
TYPECASTMETHOD(Type,SetTextSizePixels,TAttText)(p)->SetTextSizePixels(npixels);\
}

#undef TATTTEXT_DEF_NONVIRT
#define TATTTEXT_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTAttText ( int align, double angle, int color, int font, double tsize )\
{\
Type * newp = new Type (align, angle, color, font, tsize); \
return to_nonconst<Type ## _t, Type >(newp);\
}

DELETABLE_DECL_VIRT(TAttText);


TATTTEXT_DECL_VIRT(TAttText);


TATTTEXT_DECL_NONVIRT(TAttText);


#endif // __HROOT_CORE__TAttText__

#ifdef __cplusplus
}
#endif
