#include <MacroPatternMatch.h>

#include "HROOTCoreTDictionary.h"
#include "TClass.h"
#include "HROOTCoreTClass.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TDICTIONARY_DEF_VIRT(TClass)
TNAMED_DEF_VIRT(TClass)
TOBJECT_DEF_VIRT(TClass)
DELETABLE_DEF_VIRT(TClass)

TCLASS_DEF_VIRT(TClass)

TCLASS_DEF_NONVIRT(TClass)


