#include <MacroPatternMatch.h>

#include "HROOTCoreTObject.h"
#include "HROOTCoreTKey.h"
#include "HROOTCoreTNamed.h"
#include "TDirectory.h"
#include "HROOTCoreTDirectory.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TNAMED_DEF_VIRT(TDirectory)
TOBJECT_DEF_VIRT(TDirectory)
DELETABLE_DEF_VIRT(TDirectory)

TDIRECTORY_DEF_VIRT(TDirectory)

TDIRECTORY_DEF_NONVIRT(TDirectory)


