#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__TDirectory__
#define __HROOT_CORE__TDirectory__

#include "HROOT-coreType.h"

#include "HROOTCoreTNamed.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TDIRECTORY_DECL_VIRT
#define TDIRECTORY_DECL_VIRT(Type) \
void Type ## _Append ( Type ## _p p, TObject_p obj, int replace ); \
void Type ## _addD ( Type ## _p p, TObject_p obj, int replace ); \
int Type ## _AppendKey ( Type ## _p p, TKey_p key ); \
void Type ## _Close ( Type ## _p p, const char* option ); \
TObject_p Type ## _Get ( Type ## _p p, const char* namecycle ); \
int Type ## _cd_TDirectory ( Type ## _p p, const char* path )

#undef TDIRECTORY_DECL_NONVIRT
#define TDIRECTORY_DECL_NONVIRT(Type) \
void Type ## _tDirectoryAddDirectory ( int add ); \
int Type ## _tDirectoryAddDirectoryStatus (  )

#undef TDIRECTORY_DEF_VIRT
#define TDIRECTORY_DEF_VIRT(Type)\
void Type ## _Append ( Type ## _p p, TObject_p obj, int replace )\
{\
TYPECASTMETHOD(Type,Append,TDirectory)(p)->Append(to_nonconst<TObject,TObject_t>(obj), replace);\
}\
void Type ## _addD ( Type ## _p p, TObject_p obj, int replace )\
{\
TYPECASTMETHOD(Type,addD,TDirectory)(p)->Add(to_nonconst<TObject,TObject_t>(obj), replace);\
}\
int Type ## _AppendKey ( Type ## _p p, TKey_p key )\
{\
return TYPECASTMETHOD(Type,AppendKey,TDirectory)(p)->AppendKey(to_nonconst<TKey,TKey_t>(key));\
}\
void Type ## _Close ( Type ## _p p, const char* option )\
{\
TYPECASTMETHOD(Type,Close,TDirectory)(p)->Close(option);\
}\
TObject_p Type ## _Get ( Type ## _p p, const char* namecycle )\
{\
return to_nonconst<TObject_t,TObject>((TObject*)TYPECASTMETHOD(Type,Get,TDirectory)(p)->Get(namecycle));\
}\
int Type ## _cd_TDirectory ( Type ## _p p, const char* path )\
{\
return TYPECASTMETHOD(Type,cd_TDirectory,TDirectory)(p)->cd(path);\
}

#undef TDIRECTORY_DEF_NONVIRT
#define TDIRECTORY_DEF_NONVIRT(Type)\
void Type ## _tDirectoryAddDirectory ( int add )\
{\
TDirectory::AddDirectory(add);\
}\
int Type ## _tDirectoryAddDirectoryStatus (  )\
{\
return TDirectory::AddDirectoryStatus();\
}

TNAMED_DECL_VIRT(TDirectory);
TOBJECT_DECL_VIRT(TDirectory);
DELETABLE_DECL_VIRT(TDirectory);


TDIRECTORY_DECL_VIRT(TDirectory);


TDIRECTORY_DECL_NONVIRT(TDirectory);


#endif // __HROOT_CORE__TDirectory__

#ifdef __cplusplus
}
#endif
