#ifdef __cplusplus
extern "C" { 
#endif 

#ifndef __HROOT_CORE__TNamed__
#define __HROOT_CORE__TNamed__

#include "HROOT-coreType.h"

#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TNAMED_DECL_VIRT
#define TNAMED_DECL_VIRT(Type) \
void Type ## _SetName ( Type ## _p p, const char* name ); \
void Type ## _SetNameTitle ( Type ## _p p, const char* name, const char* title ); \
void Type ## _SetTitle ( Type ## _p p, const char* name )

#undef TNAMED_DECL_NONVIRT
#define TNAMED_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTNamed ( const char* name, const char* title )

#undef TNAMED_DEF_VIRT
#define TNAMED_DEF_VIRT(Type)\
void Type ## _SetName ( Type ## _p p, const char* name )\
{\
TYPECASTMETHOD(Type,SetName,TNamed)(p)->SetName(name);\
}\
void Type ## _SetNameTitle ( Type ## _p p, const char* name, const char* title )\
{\
TYPECASTMETHOD(Type,SetNameTitle,TNamed)(p)->SetNameTitle(name, title);\
}\
void Type ## _SetTitle ( Type ## _p p, const char* name )\
{\
TYPECASTMETHOD(Type,SetTitle,TNamed)(p)->SetTitle(name);\
}

#undef TNAMED_DEF_NONVIRT
#define TNAMED_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTNamed ( const char* name, const char* title )\
{\
Type * newp = new Type (name, title); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TOBJECT_DECL_VIRT(TNamed);
DELETABLE_DECL_VIRT(TNamed);


TNAMED_DECL_VIRT(TNamed);


TNAMED_DECL_NONVIRT(TNamed);


#endif // __HROOT_CORE__TNamed__

#ifdef __cplusplus
}
#endif
