#include <MacroPatternMatch.h>

#include "HROOTCoreTSeqCollection.h"
#include "TObjArray.h"
#include "HROOTCoreTObjArray.h"

using namespace std;


template<class ToType, class FromType>
const ToType* to_const(const FromType* x) {
  return reinterpret_cast<const ToType*>(x);
}

template<class ToType, class FromType>
ToType* to_nonconst(FromType* x) {
  return reinterpret_cast<ToType*>(x);
}

template<class ToType, class FromType>
const ToType& to_constref(const FromType& x) {
  return reinterpret_cast<const ToType&>(x);
}

template<class ToType, class FromType>
ToType& to_nonconstref(FromType& x) {
  return reinterpret_cast<ToType&>(x);
}


#define CHECKPROTECT(x,y) IS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  IIF( CHECKPROTECT(cname,mname) ) ( \
  (to_nonconst<oname,cname ## _t>), \
  (to_nonconst<cname,cname ## _t>) )


TSEQCOLLECTION_DEF_VIRT(TObjArray)
TCOLLECTION_DEF_VIRT(TObjArray)
TOBJECT_DEF_VIRT(TObjArray)
DELETABLE_DEF_VIRT(TObjArray)

TOBJARRAY_DEF_VIRT(TObjArray)

TOBJARRAY_DEF_NONVIRT(TObjArray)


