{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Core.TApplication.Implementation where


import FFICXX.Runtime.Cast

import HROOT.Core.TApplication.RawType
import HROOT.Core.TApplication.FFI
import HROOT.Core.TApplication.Interface
import HROOT.Core.TApplication.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TQObject.RawType
import HROOT.Core.TQObject.Cast
import HROOT.Core.TQObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

import Data.Word
import Foreign.C
import Foreign.Ptr 
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITApplication TApplication where
  run = xform1 c_tapplication_run
instance ITObject TApplication where
  draw = xform1 c_tapplication_draw
  findObject = xform1 c_tapplication_findobject
  getName = xform0 c_tapplication_getname
  isA = xform0 c_tapplication_isa
  paint = xform1 c_tapplication_paint
  printObj = xform1 c_tapplication_printobj
  saveAs = xform2 c_tapplication_saveas
  write = xform3 c_tapplication_write
instance ITQObject TApplication where
instance IDeletable TApplication where
  delete = xform0 c_tapplication_delete

instance ITApplication (Exist TApplication) where
  run (ETApplication x) = run x
instance ITObject (Exist TApplication) where
  draw (ETApplication x) = draw x
  findObject (ETApplication x) = findObject x
  getName (ETApplication x) = getName x
  isA (ETApplication x) = isA x
  paint (ETApplication x) = paint x
  printObj (ETApplication x) = printObj x
  saveAs (ETApplication x) = saveAs x
  write (ETApplication x) = write x
instance ITQObject (Exist TApplication) where

instance IDeletable (Exist TApplication) where
  delete (ETApplication x) = delete x


newTApplication :: CString -> (Ptr CInt) -> (Ptr CString) -> IO TApplication
newTApplication = xform2 c_tapplication_newtapplication





instance FPtr (Exist TApplication) where
  type Raw (Exist TApplication) = RawTApplication
  get_fptr (ETApplication obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETApplication (cast_fptr_to_obj (fptr :: ForeignPtr RawTApplication) :: TApplication)
