{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Core.TArrayC.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Core.TArrayC.RawType

import HROOT.Core.TArray.Interface
---- ============ ----



class (ITArray a) => ITArrayC a where

instance Existable TArrayC where
  data Exist TArrayC = forall a. (FPtr a, ITArrayC a) => ETArrayC a

upcastTArrayC :: (FPtr a, ITArrayC a) => a -> TArrayC
upcastTArrayC h = let fh = get_fptr h
                      fh2 :: ForeignPtr RawTArrayC = castForeignPtr fh
                  in cast_fptr_to_obj fh2

downcastTArrayC :: (FPtr a, ITArrayC a) => TArrayC -> a 
downcastTArrayC h = let fh = get_fptr h
                        fh2 = castForeignPtr fh
                    in cast_fptr_to_obj fh2
