{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Core.TArrayD.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Core.TArrayD.RawType

import HROOT.Core.TArray.Interface
---- ============ ----



class (ITArray a) => ITArrayD a where

instance Existable TArrayD where
  data Exist TArrayD = forall a. (FPtr a, ITArrayD a) => ETArrayD a

upcastTArrayD :: (FPtr a, ITArrayD a) => a -> TArrayD
upcastTArrayD h = let fh = get_fptr h
                      fh2 :: ForeignPtr RawTArrayD = castForeignPtr fh
                  in cast_fptr_to_obj fh2

downcastTArrayD :: (FPtr a, ITArrayD a) => TArrayD -> a 
downcastTArrayD h = let fh = get_fptr h
                        fh2 = castForeignPtr fh
                    in cast_fptr_to_obj fh2
