{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Core.TArrayL64.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Core.TArrayL64.RawType

import HROOT.Core.TArray.Interface
---- ============ ----



class (ITArray a) => ITArrayL64 a where

instance Existable TArrayL64 where
  data Exist TArrayL64 = forall a. (FPtr a, ITArrayL64 a) => ETArrayL64 a

upcastTArrayL64 :: (FPtr a, ITArrayL64 a) => a -> TArrayL64
upcastTArrayL64 h = let fh = get_fptr h
                        fh2 :: ForeignPtr RawTArrayL64 = castForeignPtr fh
                    in cast_fptr_to_obj fh2

downcastTArrayL64 :: (FPtr a, ITArrayL64 a) => TArrayL64 -> a 
downcastTArrayL64 h = let fh = get_fptr h
                          fh2 = castForeignPtr fh
                      in cast_fptr_to_obj fh2
