{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Core.TAtt3D.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Core.TAtt3D.RawType

import HROOT.Core.Deletable.Interface
---- ============ ----



class (IDeletable a) => ITAtt3D a where

instance Existable TAtt3D where
  data Exist TAtt3D = forall a. (FPtr a, ITAtt3D a) => ETAtt3D a

upcastTAtt3D :: (FPtr a, ITAtt3D a) => a -> TAtt3D
upcastTAtt3D h = let fh = get_fptr h
                     fh2 :: ForeignPtr RawTAtt3D = castForeignPtr fh
                 in cast_fptr_to_obj fh2

downcastTAtt3D :: (FPtr a, ITAtt3D a) => TAtt3D -> a 
downcastTAtt3D h = let fh = get_fptr h
                       fh2 = castForeignPtr fh
                   in cast_fptr_to_obj fh2
