{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Core.TGlobal.Implementation where


import FFICXX.Runtime.Cast

import HROOT.Core.TGlobal.RawType
import HROOT.Core.TGlobal.FFI
import HROOT.Core.TGlobal.Interface
import HROOT.Core.TGlobal.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TDictionary.RawType
import HROOT.Core.TDictionary.Cast
import HROOT.Core.TDictionary.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

import Data.Word
import Foreign.C
import Foreign.Ptr 
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITGlobal TGlobal where
instance ITDictionary TGlobal where
instance ITNamed TGlobal where
  setName = xform1 c_tglobal_setname
  setNameTitle = xform2 c_tglobal_setnametitle
  setTitle = xform1 c_tglobal_settitle
instance ITObject TGlobal where
  draw = xform1 c_tglobal_draw
  findObject = xform1 c_tglobal_findobject
  getName = xform0 c_tglobal_getname
  isA = xform0 c_tglobal_isa
  paint = xform1 c_tglobal_paint
  printObj = xform1 c_tglobal_printobj
  saveAs = xform2 c_tglobal_saveas
  write = xform3 c_tglobal_write
instance IDeletable TGlobal where
  delete = xform0 c_tglobal_delete

instance ITGlobal (Exist TGlobal) where

instance ITDictionary (Exist TGlobal) where

instance ITNamed (Exist TGlobal) where
  setName (ETGlobal x) = setName x
  setNameTitle (ETGlobal x) = setNameTitle x
  setTitle (ETGlobal x) = setTitle x
instance ITObject (Exist TGlobal) where
  draw (ETGlobal x) = draw x
  findObject (ETGlobal x) = findObject x
  getName (ETGlobal x) = getName x
  isA (ETGlobal x) = isA x
  paint (ETGlobal x) = paint x
  printObj (ETGlobal x) = printObj x
  saveAs (ETGlobal x) = saveAs x
  write (ETGlobal x) = write x
instance IDeletable (Exist TGlobal) where
  delete (ETGlobal x) = delete x







instance FPtr (Exist TGlobal) where
  type Raw (Exist TGlobal) = RawTGlobal
  get_fptr (ETGlobal obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETGlobal (cast_fptr_to_obj (fptr :: ForeignPtr RawTGlobal) :: TGlobal)
