{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Core.TKey.Implementation where


import FFICXX.Runtime.Cast

import HROOT.Core.TKey.RawType
import HROOT.Core.TKey.FFI
import HROOT.Core.TKey.Interface
import HROOT.Core.TKey.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

import Data.Word
import Foreign.C
import Foreign.Ptr 
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITKey TKey where
instance ITNamed TKey where
  setName = xform1 c_tkey_setname
  setNameTitle = xform2 c_tkey_setnametitle
  setTitle = xform1 c_tkey_settitle
instance ITObject TKey where
  draw = xform1 c_tkey_draw
  findObject = xform1 c_tkey_findobject
  getName = xform0 c_tkey_getname
  isA = xform0 c_tkey_isa
  paint = xform1 c_tkey_paint
  printObj = xform1 c_tkey_printobj
  saveAs = xform2 c_tkey_saveas
  write = xform3 c_tkey_write
instance IDeletable TKey where
  delete = xform0 c_tkey_delete

instance ITKey (Exist TKey) where

instance ITNamed (Exist TKey) where
  setName (ETKey x) = setName x
  setNameTitle (ETKey x) = setNameTitle x
  setTitle (ETKey x) = setTitle x
instance ITObject (Exist TKey) where
  draw (ETKey x) = draw x
  findObject (ETKey x) = findObject x
  getName (ETKey x) = getName x
  isA (ETKey x) = isA x
  paint (ETKey x) = paint x
  printObj (ETKey x) = printObj x
  saveAs (ETKey x) = saveAs x
  write (ETKey x) = write x
instance IDeletable (Exist TKey) where
  delete (ETKey x) = delete x







instance FPtr (Exist TKey) where
  type Raw (Exist TKey) = RawTKey
  get_fptr (ETKey obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETKey (cast_fptr_to_obj (fptr :: ForeignPtr RawTKey) :: TKey)
