{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Core.TObjArray.Implementation where


import FFICXX.Runtime.Cast

import HROOT.Core.TObjArray.RawType
import HROOT.Core.TObjArray.FFI
import HROOT.Core.TObjArray.Interface
import HROOT.Core.TObjArray.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TSeqCollection.RawType
import HROOT.Core.TSeqCollection.Cast
import HROOT.Core.TSeqCollection.Interface
import HROOT.Core.TCollection.RawType
import HROOT.Core.TCollection.Cast
import HROOT.Core.TCollection.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

import Data.Word
import Foreign.C
import Foreign.Ptr 
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITObjArray TObjArray where
instance ITSeqCollection TObjArray where
instance ITCollection TObjArray where
instance ITObject TObjArray where
  draw = xform1 c_tobjarray_draw
  findObject = xform1 c_tobjarray_findobject
  getName = xform0 c_tobjarray_getname
  isA = xform0 c_tobjarray_isa
  paint = xform1 c_tobjarray_paint
  printObj = xform1 c_tobjarray_printobj
  saveAs = xform2 c_tobjarray_saveas
  write = xform3 c_tobjarray_write
instance IDeletable TObjArray where
  delete = xform0 c_tobjarray_delete

instance ITObjArray (Exist TObjArray) where

instance ITSeqCollection (Exist TObjArray) where

instance ITCollection (Exist TObjArray) where

instance ITObject (Exist TObjArray) where
  draw (ETObjArray x) = draw x
  findObject (ETObjArray x) = findObject x
  getName (ETObjArray x) = getName x
  isA (ETObjArray x) = isA x
  paint (ETObjArray x) = paint x
  printObj (ETObjArray x) = printObj x
  saveAs (ETObjArray x) = saveAs x
  write (ETObjArray x) = write x
instance IDeletable (Exist TObjArray) where
  delete (ETObjArray x) = delete x







instance FPtr (Exist TObjArray) where
  type Raw (Exist TObjArray) = RawTObjArray
  get_fptr (ETObjArray obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETObjArray (cast_fptr_to_obj (fptr :: ForeignPtr RawTObjArray) :: TObjArray)
