{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Core.TObjArray.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Core.TObjArray.RawType

import HROOT.Core.TSeqCollection.Interface
---- ============ ----



class (ITSeqCollection a) => ITObjArray a where

instance Existable TObjArray where
  data Exist TObjArray = forall a. (FPtr a, ITObjArray a) => ETObjArray a

upcastTObjArray :: (FPtr a, ITObjArray a) => a -> TObjArray
upcastTObjArray h = let fh = get_fptr h
                        fh2 :: ForeignPtr RawTObjArray = castForeignPtr fh
                    in cast_fptr_to_obj fh2

downcastTObjArray :: (FPtr a, ITObjArray a) => TObjArray -> a 
downcastTObjArray h = let fh = get_fptr h
                          fh2 = castForeignPtr fh
                      in cast_fptr_to_obj fh2
