{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, 
             EmptyDataDecls, ExistentialQuantification, ScopedTypeVariables #-}

-- module HROOT.Class.Interface where

module HROOT.Core.TQObject.Interface where


import Data.Word
import Foreign.C
import Foreign.Ptr
import Foreign.ForeignPtr
import FFICXX.Runtime.Cast

import HROOT.Core.TQObject.RawType

import HROOT.Core.Deletable.Interface
---- ============ ----



class (IDeletable a) => ITQObject a where

instance Existable TQObject where
  data Exist TQObject = forall a. (FPtr a, ITQObject a) => ETQObject a

upcastTQObject :: (FPtr a, ITQObject a) => a -> TQObject
upcastTQObject h = let fh = get_fptr h
                       fh2 :: ForeignPtr RawTQObject = castForeignPtr fh
                   in cast_fptr_to_obj fh2

downcastTQObject :: (FPtr a, ITQObject a) => TQObject -> a 
downcastTQObject h = let fh = get_fptr h
                         fh2 = castForeignPtr fh
                     in cast_fptr_to_obj fh2
