{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.Core.TSeqCollection.Implementation where


import FFICXX.Runtime.Cast

import HROOT.Core.TSeqCollection.RawType
import HROOT.Core.TSeqCollection.FFI
import HROOT.Core.TSeqCollection.Interface
import HROOT.Core.TSeqCollection.Cast
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TCollection.RawType
import HROOT.Core.TCollection.Cast
import HROOT.Core.TCollection.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

import Data.Word
import Foreign.C
import Foreign.Ptr 
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITSeqCollection TSeqCollection where
instance ITCollection TSeqCollection where
instance ITObject TSeqCollection where
  draw = xform1 c_tseqcollection_draw
  findObject = xform1 c_tseqcollection_findobject
  getName = xform0 c_tseqcollection_getname
  isA = xform0 c_tseqcollection_isa
  paint = xform1 c_tseqcollection_paint
  printObj = xform1 c_tseqcollection_printobj
  saveAs = xform2 c_tseqcollection_saveas
  write = xform3 c_tseqcollection_write
instance IDeletable TSeqCollection where
  delete = xform0 c_tseqcollection_delete

instance ITSeqCollection (Exist TSeqCollection) where

instance ITCollection (Exist TSeqCollection) where

instance ITObject (Exist TSeqCollection) where
  draw (ETSeqCollection x) = draw x
  findObject (ETSeqCollection x) = findObject x
  getName (ETSeqCollection x) = getName x
  isA (ETSeqCollection x) = isA x
  paint (ETSeqCollection x) = paint x
  printObj (ETSeqCollection x) = printObj x
  saveAs (ETSeqCollection x) = saveAs x
  write (ETSeqCollection x) = write x
instance IDeletable (Exist TSeqCollection) where
  delete (ETSeqCollection x) = delete x







instance FPtr (Exist TSeqCollection) where
  type Raw (Exist TSeqCollection) = RawTSeqCollection
  get_fptr (ETSeqCollection obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETSeqCollection (cast_fptr_to_obj (fptr :: ForeignPtr RawTSeqCollection) :: TSeqCollection)
